using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;

namespace SC.DebugTool
{
    static public class StackHistory
    {
        // fQ[g
        private delegate string GetCallMethodHistoryFormatDelegate(StackFrame sf);

        #region 萔
        /// <summary>
        /// o͌`łB
        /// </summary>
        public enum CallMethodHistoryFormat
        {
            Text,
            Csv,
        }
        #endregion

        #region oϐ
        /// <summary>
        /// o͌`ɂǗĂ܂B
        /// </summary>
        static private Dictionary<CallMethodHistoryFormat, GetCallMethodHistoryFormatDelegate> CallMethodHistoryOutput = new Dictionary<CallMethodHistoryFormat, GetCallMethodHistoryFormatDelegate>();
        #endregion

        #region RXgN^
        /// <summary>
        /// RXgN^łB
        /// </summary>
        static StackHistory()
        {
            foreach (CallMethodHistoryFormat f in Enum.GetValues(typeof(CallMethodHistoryFormat)))
            {
                CallMethodHistoryOutput.Add(f, OutputNone);
            }

            CallMethodHistoryOutput[CallMethodHistoryFormat.Text] = OutputText;
            CallMethodHistoryOutput[CallMethodHistoryFormat.Csv] = OutputCSV;
        }
        #endregion

        #region \bh
        #region pubN\bh
        /// <summary>
        /// ĂяõNX⃁\bh̗擾܂B
        /// </summary>
        /// <param name="format">o͌`(Text,Csv)</param>
        /// <returns>
        /// ĂяõNX⃁\bh̗
        /// </returns>
        static public string GetCallMethodHistory(CallMethodHistoryFormat format)
        {
            string history = string.Empty;
            StackTrace st = new StackTrace(true);

            for (int i = 1; i < st.FrameCount; i++)
            {
                StackFrame sf = st.GetFrame(i);

                history += CallMethodHistoryOutput[format](sf);
            }

            return history;
        }
        #endregion

        #region vCx[g\bh
        /// <summary>
        /// GetCallMethodHistory( )Ăяo_~[̏o͏łB
        /// _~[
        /// </summary>
        /// <param name="sf">StackFrameIuWFNg</param>
        /// <returns>string.Empty</returns>
        static private string OutputNone(StackFrame sf)
        {
            return string.Empty;
        }
        /// <summary>
        /// GetCallMethodHistory( )ĂяoText`̏o͏łB
        /// </summary>
        /// <param name="sf">StackFrameIuWFNg</param>
        /// <returns>Xy[X؂Ń\bhANXAt@CAs̏ɏo͂܂B</returns>
        static private string OutputText(StackFrame sf)
        {
            string history = string.Empty;

            // \bh
            history += sf.GetMethod();

            // NX
            history += " " + sf.GetMethod().ReflectedType;

            // t@C
            history += " " + sf.GetFileName();

            // s
            history += " " + sf.GetFileLineNumber();

            // Ō͉s
            history += Environment.NewLine;

            return history;
        }
        /// <summary>
        /// GetCallMethodHistory( )ĂяoCsv`̏o͏łB
        /// </summary>
        /// <param name="sf">StackFrameIuWFNg</param>
        /// <returns>J}؂Ń\bhANXAt@CAs̏ɏo͂܂B</returns>
        static private string OutputCSV(StackFrame sf)
        {
            string history = string.Empty;

            // \bh
            history += "\"" + sf.GetMethod() + "\"";

            // NX
            history += ",\"" + sf.GetMethod().ReflectedType + "\"";

            // t@C
            history += ",\"" + sf.GetFileName() + "\"";

            // s
            history += ",\"" + sf.GetFileLineNumber() + "\"";

            // Ō͉s
            history += Environment.NewLine;

            return history;
        }

        #endregion
        #endregion
    }
}
